<?php

/*
 * virtuatables 0.1 - Andr Bruce ( abruce _at_ virtuaserver.com.br )
 * Create a "virtual" iptables support inside a vserver
 * First version: 23/11/2006
 */

/*
 * Configuration
 */
 # Path to vserver-info binary
$DEF_VSERVER_INFO_BIN="/usr/sbin/vserver-info";
# Port to listen for connections
$localport="4558";

# Not working yet
$debug=1;


#$localport=$argv[1];



// Extras
$buffersize="1024";

set_time_limit(1800);

// TODO Organizar code
// Todo: Corrigir o segundo known bug, retornando o erro real!

// Arvore de funces: 
// main_loop -> trata_conexao_recebida -> parsea_recebe
// main_loop -> trata_conexao_recebida -> parsea_recebe -> parsea_iptables_arg : Retorna um array com $options, que so os argumentos recebidos
// main_loop -> trata_conexao_recebida -> parsea_recebe -> trata_target : Verifica se os targets recebidos so vlidos
// main_loop -> trata_conexao_recebida -> parsea_recebe -> trata_target -> chains_lista : Ir buscar a lista de chains disponveis para este vserver e verificar se as chains input e output existem: Sempre devem existir! (somente fazer esta verificao se estamos no ALL_RULE (ver na funcao a especificacao))
// main_loop -> trata_conexao_recebida -> parsea_recebe -> trata_target -> trata_chains : Verifica qual a chain recebida pelo usuario (-A OUTPUT por ex). Chamaremos esta chain de nome virtual, que  como o usurio ve esta chain, Iremos adapt-lo para um nome real que  com o qual iremos trabalhar
// main_loop -> trata_conexao_recebida -> parsea_recebe -> trata_target -> trata_rule : Ir gerar a linha de comando a ser executada pelo iptables
// main_loop -> trata_conexao_recebida -> parsea_recebe -> trata_target -> iptables : Ir executar a linha de comando e retornar o output
// main_loop -> trata_conexao_recebida -> parsea_recebe -> trata_target -> trata_output : Trata o output antes de exibi-lo, convertendo os nomes "reais" para nomes "virtuais": Ir exibir pro usurio a chain INPUT ao invs de teste__INPUT

// Pontos:
// 1 - De qual vserver veio este comando: baseado no source_ip da conexao
// 2 - Quais IPs pertencem a este vserver: Buscados a partir do xid
// 3 - Como garantir que somente o root poder executar o comand: A conexao precisa ter origem em portas abaixo de 1024 

// Restries: Estaremos trabalhando somente com a tabela filter

// Observaes: Quanto a criao de chains: Usurio pode criar chains livremente, no existe "perigo". A questo est no fato de que estas chains sero apontadas somente por suas chains.

// Todo POLICY da chain, remoo, etc.
// The created chains by a vserver will have the name $vserver__CHAINNAME
// Todo: E se o nome do vserver tiver . ou numeros em seu nome? Converter todos os caracteres invlidos!
// Todo: Contador para evitar dos (numero de requisicoes por segundo E numero maximo de regras)
// Todo: Criar iptables-save e iptables-restore
// Todo: Verificar se todos os requisitos esto ok (vserver-info existe, permisso de leitura ao diretrio /etc, etc)

// Possible bugs: Se o nome de algum host for igual ao nome da chains (o nome REAL: vserver__nomedachain), este nome pode ser alterado pelo nome virtual da chain na listagem de regras do iptables
// KNOWN BUG: First time it runs it shows nothing.
// KNOWN BUGS: Se usurio digitar --destinatoin (sim, incorreto), este parametro ser ignorado e o destino no adicionado: PESSIMO , poderia resultar em um DROP em ALL

main_loop();

// Function iptables
// $rule -> rule to be executed
// $do_output -> 0 wont give iptables' output for this rule to the guest client
// $do_output -> 1 WILL give iptables' output for this rule to the guest client
function iptables($rule,$do_output=0)
{
	global $debug;

	if($do_output == 1)
		$redirect=" 2>&1 ";
	else
		$redirect=NULL;

	$run="/sbin/iptables $rule $redirect";
	if($debug == 1)
		echo "Executando: $run\n";

	$res=shell_exec($run);

	return($res);
}

// Funcao limpa_array
// Ira excluir as linhas vazias, ordenar e retornar o numero do ultimo elemento
function limpa_array($array)
{
	$fd=$array;
	// ordenando array e definindo i como a ultima posicao
	if(is_array($fd))
	{
		sort($fd);
		$fd=array_values($fd);
		$j=0; // contador de retorno
		for($i=0;$i<count($fd);$i++)
			if($fd[$i] != NULL)
			{
				$ret[$j]=$fd[$i];
				$j++;
			}
	}
	// fim - ordenando array e definindo i como a ultima posicao
	return($ret);
}

function main_loop()
{
	global $localip,$localport,$buffersize;

	// Criando socket para receber conexao
	$socket=socket_create_listen($localport);
	if($socket === FALSE)
		die("Erro executando listen");
	if (!socket_set_option($socket, SOL_SOCKET, SO_REUSEADDR, 1)) 
	   echo socket_strerror(socket_last_error());
	if (!socket_set_nonblock($socket)) // $socket is now nonblocking
   		echo socket_strerror(socket_last_error());

	/*
	 * Lendo do servidor
	 */
	$i=0;
	echo "Aguardando conexes na porta $localport\n";
	$i=0;

	// Loop infinito
	while(1)
	{
		// Verificando se recebmos uma nova conexao
		$fd[$i] = @socket_accept($socket);
		if($fd[$i] !== FALSE)
		{
			echo "Conexo recebida $i!\n";

			// Buscando IP origem
			socket_getpeername ( $fd[$i], &$source_ip, &$source_port );

			echo "ip origem  $source_ip\n";
			echo "porta origem  $source_port\n";
			// Buscando nome deste vserver e lista de IPs

			// Setando o fd criando como non-block
			if (!socket_set_option($fd[$i], SOL_SOCKET, SO_REUSEADDR, 1)) 
				echo socket_strerror(socket_last_error());
			if (!socket_set_nonblock($fd[$i])) // $socket is now nonblocking
				echo socket_strerror("ERRO: ".socket_last_error());

			// Nao podemos incrementar sempre, em algum momento ir atingir o limite
			// existem remocoes qdo uma conexao termina, entao reordenando e colocando na ultima posicao
			$fd=limpa_array($fd);
			$i=count($fd);
		}

		// Varrendo todas as conexoes abertas, verificando por mensagens e verificando se ainda estao abertas
		for($j=0;$j<count($fd);$j++) // varrendo todos os fds disponiveis e verificando se existem mensagens
		{
			if($fd[$j] !== FALSE)
			{
				$retval=trata_conexao_recebida($fd[$j],$source_ip,$source_port);
				
				if($retval == -1) // conexao perdida
				{
					echo "Conexao perdida: $j (total:".count($fd).")\n";
					socket_close($fd[$j]);
					unset($fd[$j]);
					$fd=limpa_array($fd);
					$i=count($fd);
				} // if
				if($retval == 1)
				{
					echo "Conexao dropada: $j (total:".count($fd).")\n";
					socket_close($fd[$j]);
					unset($fd[$j]);
					$fd=limpa_array($fd);
					$i=count($fd);
				}
			} // if
		} // for

		usleep(300);
		//sleep(1);

	} // while

}

// Se $vserver=NULL, retorna todos os chains
function chains_lista($vserver=NULL)
{
	$res=iptables("-L -n");
	$tmp=explode("\n",$res);

	$iret=0; // contador de retorno

	for($i=0;$i<count($tmp);$i++)
	{
		if(substr($tmp[$i],0,6) == "Chain ")
		{
//			echo "Entrou: $tmp[$i]\n";
			// posicao da final da string do nome da chain ex: Chain teste_OUTPUT (
			$pos=strpos($tmp[$i],"(",7);
			$ret[$iret]=trim(substr($tmp[$i],6,$pos-6));
			$iret++;
		}
	}
	// At this point we have all chain names on the array $ret[$i]


	// Se nao especificamos nenhum vserver, retornando tudo
	if($vserver == NULL)
		return($ret);

	// Finding just the chains which belong to this vserver (they are named $vserver_USERDEFINEDNAME)
	$iret=0;
	for($i=0;$i<count($ret);$i++)
	{
		// Finding chains which starts with $vserver_
		if(substr($ret[$i],0,strlen($vserver."__")) == $vserver."__")
		{
			$retorno[$iret]=$ret[$i];
			$iret++;
		} // if
	} // for

//	print_r($retorno);
	return($retorno);
}

function chains_existe($chain_name)
{
	$ret=chains_lista();
	for($i=0;$i<count($ret);$i++)
	{
		if($ret[$i] == $chain_name)
			return(true);
	}
	return(false);
}

// Ir buscar todas as regras da chain $chain (INPUT ou OUTPUT por ex) que tenham como target $target e retornar um array no formato:
// Utilizada pela funo chains_cria: Confirmando que existem regras para todos os ips deste vserver apontando para este chain - quando alteram-se ips de um vserver, sao removidos os apontamentos - novos ips, cria-se os apontamentos (isso na funcao chains_cria) 
// $var[$i][source]
// $var[$i][destination]
function iptables_lista_chain_to_target($chain,$target)
{
	$res=iptables("-L $chain -n");
//	print_r($res);
	$tmp=explode("\n",$res);
//	print_r($tmp);
	
	$iret=0;
	for($i=0;$i<count($tmp);$i++)
	{
		// Verificando se esta linha do firewall se refere a uma regra com target neste chain:
		// teste__INPUT  all  --  0.0.0.0/0            1.2.3.4
		if(substr($tmp[$i],0,strlen($target)) == $target)
		{
//			echo "Encontrou: $tmp[$i]\n";
			$tmp2=sscanf($tmp[$i],"%s %s %s %s %s");
//			print_r($tmp2);
/*
    [0] => teste__INPUT
    [1] => all
    [2] => --
    [3] => 0.0.0.0/0
    [4] => 1.2.3.4
*/
			$ret[$iret][source]=$tmp2[3];
			$ret[$iret][destination]=$tmp2[4];
			$iret++;
			
		} // if
	} // for
	return($ret);
} // function

// CHANGE_NAME
// $chain_name: Name of the chain to be created/checked
// $from_chain: If we are creating an OUTPUT or INPUT chain
// $ips: Array containing the IPs that belong to this vserver: $ips[$i]="ip" or $ips="ip"
// Consiste na criao da chain (iptables -N chain) quando nao existe e criao de regras aopntando todos os ips para esta chain(seja na input ou output)
function chains_cria($chain_name,$from_chain,$ips)
{
	if(!chains_existe($chain_name))
		iptables(" -N $chain_name");

	if(!is_array($ips))
		$ips=array("0"=>$ips);

	// Antes de criar a regra, varrer todo o INPUT (ou OUTPUT) verificando quais regras tem como target este chain. Comparar ento com os IPs deste vserver, removendo os chains incorretos. 
	$lista=iptables_lista_chain_to_target($chain=$from_chain,$target=$chain_name);

	/*
	 * INPUT
	 */

	// Verificando se existem regras para todos os ips deste vserver para o chain em questao
	if($from_chain == "INPUT")
	for($i=0;$i<count($ips);$i++)
	{
		// Varrendo regras j disponveis

		// Verificando se j existe regra para este IP
		$regra_encontrada=0;
		for($j=0;$j<count($lista);$j++)
		{
			if($lista[$j][destination] == $ips[$i])
				$regra_encontrada=1;
		}
		if($regra_encontrada == 0)
			iptables("-A INPUT -d $ips[$i] -j $chain_name");
	} // for

	// Verificando se existem regras para IPs no existentes
	if($from_chain == "INPUT")
	for($j=0;$j<count($lista);$j++)
	{
		$ip_encontrado=0;
		for($i=0;$i<count($ips);$i++)
		{
			if($lista[$j][destination] == $ips[$i])
				$ip_encontrado=1;
		} // for
		if($ip_encontrado == 0)
			iptables("-D INPUT -d ".$lista[$j][destination]." -j $chain_name");
	} // for

	/*
	 * OUTPUT
	 */

	// Verificando se existem regras para todos os ips deste vserver para o chain em questao
	if($from_chain == "OUTPUT")
	for($i=0;$i<count($ips);$i++)
	{
		// Varrendo regras j disponveis

		// Verificando se j existe regra para este IP
		$regra_encontrada=0;
		for($j=0;$j<count($lista);$j++)
		{
			if($lista[$j][source] == $ips[$i])
				$regra_encontrada=1;
		}
		if($regra_encontrada == 0)
			iptables("-A OUTPUT -s $ips[$i] -j $chain_name");
	} // for

	// Verificando se existem regras para IPs no existentes
	if($from_chain == "OUTPUT")
	for($j=0;$j<count($lista);$j++)
	{
		$ip_encontrado=0;
		for($i=0;$i<count($ips);$i++)
		{
			if($lista[$j][source] == $ips[$i])
				$ip_encontrado=1;
		} // for
		if($ip_encontrado == 0)
			iptables("-D OUTPUT -s ".$lista[$j][source]." -j $chain_name");
	} // for

}

// Function CHANGE_NAME
// Based on the received arguments we will have to choose where to place the received rule
// This algorithm will choose what chain name will be used for the received rule
// $options -> Array containing all received options and parsed by the function "parsea_recebe"
// *** VSERVERNAME???????????????????? ***************
function trata_chain($vserver,$options,$ips)
{
	// Cases:
	// 1: Changing rules on the INPUT or OUTPUT chain

	if( 
		($options["A"] == "INPUT") || ($options["I"] == "INPUT") || ($options["D"] == "INPUT" ) 
		||
		($options["L"] == "INPUT") || ($options["F"] == "INPUT") || ($options["Z"] == "INPUT" ) 
		)
	{
		// This user wants to change his "virtual" INPUT chain, which will be called
		$chain_name=$vserver."__INPUT";
		chains_cria($chain_name,$from_chain="INPUT",$ips);
//											"-A INPUT -d @__IP__@ -j $chain_name",
		return $chain_name;
	}

	if(
		($options["A"] == "OUTPUT") || ($options["I"] == "OUTPUT") || ($options["D"] == "OUTPUT" )
		|| 
		($options["L"] == "OUTPUT") || ($options["F"] == "OUTPUT") || ($options["Z"] == "OUTPUT" ) 
		)
	{
		// This user wants to change his "virtual" INPUT chain, which will be called
		$chain_name=$vserver."__OUTPUT";
		chains_cria($chain_name,$from_chain="OUTPUT",$ips);
		return $chain_name;
	}


	// Chegando aqui  porque no entramos em nenhum dos dois casos.
	// ARRAY OBTIDO NA FUNCAO trata_rule
	$allowed_options_require_chain=array("A"=>"1","D"=>"1","I"=>"1",
																"append"=>"2","delete"=>"2","insert"=>"2",
																"L"=>"1","F"=>"1","Z"=>"1",
																"list"=>"2","flush"=>"2","zero"=>"2",
																"N"=>"1","X"=>"1",
																"new-chain"=>"2","delete-chain"=>"2");

	// nao tem muita lgica, s podemos executar uma chain por comando do iptables, entao iremos parar no primeiro retornando seu nome
	while(list($key,$value) = each($allowed_options_require_chain))
	{
		if($options["$key"] != NULL)
		{
			$options["$key"]=$vserver."__".$options["$key"];
			return($options["$key"]);
		}
	}


//		"iptables -A OUTPUT -s IP -j fxexperts1";
	
}

function trata_rule($options,$chain)
{
	// We just allow the options listed here to be used. Other ones will be ignored.
	// Use 1 for the ones that use "-"
	// Use 2 for the ones that use "--"
	$allowed_options=array("p"=>"1","s"=>"1","d"=>"1",
										"protocol"=>"2","source"=>"2","destination"=>"2",
											"j"=>"1","v"=>"1","n"=>"1","x"=>"1",
											"jump"=>"2","verbose"=>"2","numeric"=>"2","exact"=>"2",
											"line-numbers"=>"2",
											"src-type"=>"2","dst-type"=>"2","source-ports"=>"2","sports"=>"2","destination-ports"=>"2","dports"=>"2","ports"=>"2","state"=>"2","source-port"=>"2","sport"=>"2","destination-port"=>"2","dport"=>"2","tcp-flags"=>"2","syn"=>"2","tcp-option"=>"2","mss"=>"2","reject-with"=>"2");


	// Options that are allowed but take chain name as argument, we need to replace chain name!
	// Da origem ao da funcao trata_chain
	$allowed_options_require_chain=array("A"=>"1","D"=>"1","I"=>"1",
																"append"=>"2","delete"=>"2","insert"=>"2",
																"L"=>"1","F"=>"1","Z"=>"1",
																"list"=>"2","flush"=>"2","zero"=>"2",
																"N"=>"1","X"=>"1",
																"new-chain"=>"2","delete-chain"=>"2");

	// Checking received options and generating command line for iptables
	while(list($key,$value) = each($options))
	{
//		echo "key  $key\n";
		// if this option[$i]
		// Convertendo de volta a string vazia para vazia, caso contrario teremos -n @_@_DUMMY_@_@ no comando
		if($value == "@_@_DUMMY_@_@")
			$value="";

		if($allowed_options_require_chain[$key] == "1")
		{
//			echo "KEY $key  vlida!\n";
			$cmd=$cmd." -".$key." ".$chain;
		}
		elseif($allowed_options_require_chain[$key] == "2")
		{
//			echo "KEY $key  vlida!\n";
			$cmd=$cmd." --".$key." ".$chain;
		}
		elseif($allowed_options[$key] == "1")
		{
//			echo "KEY $key  vlida!\n";
			$cmd=$cmd." -".$key." ".$value;
		}
		elseif($allowed_options[$key] == "2")
		{
//			echo "KEY $key  vlida!\n";
			$cmd=$cmd." --".$key." ".$value;
		}

	}
	return $cmd;
}

// Ir verificar se o target est OK ( um dos vlidos ou um chain que pertena a este vserver).
// Se  um chain que pertena a este vserver, realizar as devidas converses de nome.
function trata_target($vserver,$options)
{
	$allowed_targets=array("DROP","REJECT","ACCEPT");

	($options["j"] != NULL) ? 		$target=$options["j"] : NULL;
	($options["jump"] != NULL) ?	$target=$options["jump"]: NULL;

	// Se  um dos targets normais, OK! Retornar
	if(in_array($target,$allowed_targets) === TRUE)
		return($options);

	// No sendo um dos targets acima, o target  um chain (o nome informado pelo usuario precisa ser convertido) ou o target foi digitado incorretamente 
	// Forma mais simples, jogar o nome do target ao inicio da chain ($vserver_), seguindo o padrao
	$target=$vserver."__".$target;
	($options["j"] != NULL) ? 		$options["j"]=$target : NULL;
	($options["jump"] != NULL) ?	$options["jump"]=$target: NULL;
	return($options);
}

// Funcao temporaria que ira retornar o nome de um vserver e seus ips
function temp_retorna_vserver($string,$source_ip,$source_port)
{
	global $DEF_VSERVER_INFO_BIN;

	$tmp=explode(" ",$string);
	$xid=trim($tmp[0]);
	if(!is_numeric($xid))
	{
		echo "XID invlido\n";
		return NULL;
	}
	echo "xid recebido  $IP\n";
	echo "IP remoto  $source_ip\n";
	echo "Porta Remota  $source_port\n";

	// Buscando diretorio aonde se encontram as configuraes deste vserver com xid $xid

	if(!file_exists($DEF_VSERVER_INFO_BIN))
		die("Error: vserver-info binary was not found\n");
	$res=shell_exec("$DEF_VSERVER_INFO_BIN $xid ID");
	$CFGDIR=trim($res);
	if(!is_dir($CFGDIR))
	{
		echo("Erro encontrado diretrio");
		return NULL;
	}

	echo "Configuraes esto no diretrio $CFGDIR\n"; 

	// Qual o nome deste vserver?
	$tmp=explode("/",$CFGDIR);
	print_r($tmp);
	
	$vserver=trim($tmp[count($tmp)-1]);
	echo "Nome do vserver  $vserver\n";

	if(strlen($vserver) < 1)
	{
		echo "Erro obtendo nome deste vserver\n";
		return NULL;
	}

	// Buscando IPs deste vserver
	$ips=temp_lista_ips($vserver);

	// Verificando se source_ip pertence a este vserver (pode ser um vserver tentando criar regras em outro)
	$achou=0;
	for($i=0;$i<count($ips);$i++)
	{
		echo "Comparando ".trim($ips[$i][ip])." com ".trim($source_ip)."\n";
		if(trim($ips[$i][ip]) == trim($source_ip))
			$achou=1;
	}
	
	if($achou == 0)
	{
		echo "Erro! Tentando criar regra para outro vserver\n";
		return NULL;
	}

	// Chegando aqui temos o xid, nome do vserver e lista de ips deste vserver.
	// Gerando lista de ips a ser retornada
	for($i=0;$i<count($ips);$i++)
		$ips_vserver[$i]=$ips[$i][ip];

/*
 * DEPRECATED
	// Buscando nome do vserver dono do ip $IP
	$vserver=NULL;
	for($i=0;$i<count($ips);$i++)
	{
		if(trim($ips[$i][ip]) == $IP)
		{
			$vserver=trim($ips[$i][vserver]);
			break;
		}
	}

	// Se no achamos o vserver dono deste ip retornar erro
	if($vserver == NULL)
		return NULL;

	// Buscando outros ips pertencentes a este vserver
	$ipcount=0;
	for($i=0;$i<count($ips);$i++)
	{
		if($ips[$i][vserver] == $vserver)
		{
			$ips_vserver[$ipcount]=trim($ips[$i][ip]);
			$ipcount++;
		}
	}
 */
	
	$ret[ips]=$ips_vserver;
	$ret[vserver]=$vserver;	
	print_r($ret);
	return($ret);
}

function temp_lista_ips($vserver)
{
	$res=shell_exec("find /etc/vservers/$vserver | grep -i interface | grep -E 'ip$'");
	$res=explode("\n",$res);
//	print_r($res);
	for($i=0;$i<count($res);$i++)
	{
		$tmp=explode("/",$res[$i]);
//		print_r($tmp);

		$filename=trim($res[$i]);
		if(strlen($filename) < 1)
			continue;

		$run="/bin/cat ".$filename;
//		echo "run eh $run\n";
		$ret[$i][vserver]=$tmp[3];
		$ret[$i][ip]=trim(shell_exec($run));
	}
	return($ret);
}

// Function CHANGE_NAME
// Fix the name of all chains listed
// Ex: vserver_INPUT has to be shown as INPUT
function trata_output($output,$vserver)
{
	if(strlen($output) < 1)
		return($output);

	// Obtendo lista de chains (com o nome real vserver_nomedachain)
	$chains_vserver=chains_lista($vserver);
	// Gerando nome VIRTUAL (ser exibido para o usurio) a partir do nome real
	for($i=0;$i<count($chains_vserver);$i++)
	{
		$real=$chains_vserver[$i];
		$virtual=str_replace($vserver."__","",$real);
		// Gerando array que ser utilizado abaixo
		$chains[$i]["virtual"]=$real;
		$chains[$i]["real"]=$virtual;
	}

	for($i=0;$i<count($chains);$i++)
	{
		// Alterando nome das chains exibido no topo. Ex: "Chain teste__INPUT (82 references) vira "Chain INPUT (82 references)"
		// Substituindo todas as ocorrencias que de real por virtual desde que exista espaco antes do nome e ao final do nome
		// Tambm ser aproveitado para alterar o nome das chains que sao utilizadas como target (ao inves de -j DROP utiliza-se alguma chain)
//		echo "Substituir ".$chains[$i]["virtual"]." por ".$chains[$i]["real"]."\n";
		$output=str_replace(" ".$chains[$i]["virtual"]." "," ".$chains[$i]["real"]." ",$output);
//		$output=ereg_replace($pattern,$chain[$i][replacement],$output);	

		// chains podem ser utilizadas como target, alterando todas as strings com nome real por virtual, desde que tenham:
		// espaco no inicio ou fim (j ser tratado pela situao acima)
		// OU estejam no inicio da linha (tratar agora)
		$output=ereg_replace("\n".$chains[$i]["virtual"]." ","\n".$chains[$i]["real"]." ",$output);
	}
	return($output);
}

// Como detectar que uma conexo est terminada?
// (o manual do php diz que o false  erro, mas no nosso caso (nao-bloqueante) no )
// Se socket_read retornar (string:
// TRUE porque retornou $string(>0), entao conexao OK
// FALSE, conexao OK
// TRUE e strlen(string)=0 -> CONEXAO FALHOU!
function trata_conexao_recebida($fd,$source_ip,$source_port)
{
	global $buffersize;

	$string="dummy";

	if($source_port >= 1024)
	{
		socket_write($fd,"Only root can do that...\n");
		return(1);
	}

	$string=@socket_read($fd,$buffersize); // comentando senao da warning qdo nao existem mensagens
	if($string === FALSE) // conexao ok
		return;

	if(strlen($string) == 0) // conexao perdida
		return -1;

	if(strlen($string) > 0) // alguma coisa foi recebida, tratar e retornar 1
	{
		// Buscando nome e ips do vserver que est enviando a regra
		$tmp=temp_retorna_vserver($string,$source_ip,$source_port);
		$vserver=$tmp[vserver];
		$ips_vserver=$tmp[ips];
		$tmp=NULL;
		if( ($vserver == NULL) || (strlen($vserver) < 1) )
		{
			echo "\nERRO: Vserver no identificado!\n";
			return 1;
		}
		
		$options=parsea_recebe($string,$fd);
		$options=trata_target($vserver,$options);
		
		$ALL_RULE=NULL; // ALL_RULE ser utilizado para regras que se aplicam a todas as chains, exemplo -L (lista todos os chains)
		// Casos especiais, quando o usurio der um iptables -L, no iremos listar tudo, mas sim listar um a um e retornar em ordem
		if( ($options["L"] == "@_@_DUMMY_@_@") || ($options["list"] == "@_@_DUMMY_@_@") )
		{ 
			$ALL_RULE="L";
			// Iremos definir L como all rule e excluir o list (Caso contrrio, se usurio especificou --list, teremos -L e --list ao mesmo tempo )
			unset($options["list"]);
		} 
		if( ($options["F"] == "@_@_DUMMY_@_@") || ($options["flush"] == "@_@_DUMMY_@_@") )
		{
			$ALL_RULE="F";
			unset($options["flush"]);
		} 
		if( ($options["Z"] == "@_@_DUMMY_@_@") || ($options["zero"] == "@_@_DUMMY_@_@") )
		{
			$ALL_RULE="Z";
			unset($options["zero"]);
		} 
			
		if($ALL_RULE != NULL)
		{
//			echo "ENTROU NO CASO ALL_RULE: $ALL_RULE\n";
			// fazer lista para todos os chains deste server, juntar o output e exibir
			$chains_vserver=chains_lista($vserver);

			// Se INPUT ou OUTPUT no existirem, criar
			$achou_INPUT=0;	$achou_OUTPUT=0;
			for($i=0;$i<count($chains_vserver);$i++)
			{
				if($chains_vserver[$i] == $vserver."__"."INPUT")
					$achou_INPUT=1;
				if($chains_vserver[$i] == $vserver."__"."OUTPUT")
					$achou_OUTPUT=1;
			}
			// As chains INPUT e OUTPUT sempre percisam existir! Entao se elas nao existem, iremos retornar para que a prxima funo ao tentar acess-las crie-as.
			if($achou_INPUT == "0")
			{
				// Criando chain INPUT - para isto iremos criar um option temporario, simulando a criacao
				$options_temp=array("L"=>"INPUT"); trata_chain($vserver,$options_temp,$ips_vserver);
			}
			if($achou_OUTPUT == "0")
			{
				// Criando chain OUTPUT - para isto iremos criar um option temporario, simulando a criacao
				$options_temp=array("L"=>"OUTPUT"); trata_chain($vserver,$options_temp,$ips_vserver);
			}
			// FIM - Se INPUT ou OUTPUT no existirem, criar			
			
			for($i=0;$i<count($chains_vserver);$i++)
			{
				// Gerando a rule forcando com a chain em questao
				$options["$ALL_RULE"]=$chains_vserver[$i];

				$rule=trata_rule($options,$chain=$chains_vserver[$i]);
				$res=iptables($rule,$do_output=1);
				$res=trata_output($res,$vserver);

				if($i > 0) // pular uma linha qdo mairo que zero
					socket_write($fd,"\n",strlen($res));

				socket_write($fd,$res,strlen($res));
			}
			
		}
		else
		{
			$chain=trata_chain($vserver,$options,$ips_vserver);
			$rule=trata_rule($options,$chain);
			// Aqui devemos ter chain a ser utilizada e rule a ser executada
			$res=iptables($rule,$do_output=1);
			$res=trata_output($res,$vserver);
			socket_write($fd,$res,strlen($res));
		}
			return 1;
	}

}

// Parte do princpio que nunca existiro 2 espaos consecutivos na $string de argumentos recebida
// Function CHANGE_NAME
// Receive string with iptables arguments: ex: -L -t nat
// Return an $array with:
// $options[$option_name]=$value
// If there is no value for this option, it will return:
// $options[$option_name]="@_@_DUMMY_@_@"
function parsea_iptables_arg($string)
{
	$string=trim($string); // we might have \n or \r or spaces at the end of the string, removing!
	echo "parsea_iptables_arg: $string\n";
	$valid_arguments=array("L","t","A","I","D","N","j","source","s","d");
	$string_options=implode(":",$valid_arguments);

	$argv=explode(" ",$string);
/*
 iria remover espaos em branco, constatamos que o argv enviado pelo shell j vem correto
	for($i=0;$i<count($argv);$i++)
	{
		$argv[$i]=trim($argv[$i]);
		if(strlen($argv[$i]) < 1)
			unset($argv[$i]);
	}
*/

	// At the end of this loop we will have
	// $options[option_name]=value or empty
	// Ex: $options[source]="1.2.3.4"; -> If we received --source 1.2.3.4
	for($i=0;$i<count($argv);$i++)
	{
		// -- source ?
		if( ($argv[$i][0] == '-') && ($argv[$i][1] == '-') )
		{
			$option_name=substr($argv[$i],2,strlen($argv[$i])); // getting "source" from "--source"

			if($argv[$i+1][0] != '-')
				$options[$option_name]=$argv[$i+1];
			else
				$options[$option_name]="";
		}
		// -s ?
		elseif($argv[$i][0] == '-')
		{
			$option_name=substr($argv[$i],1,strlen($argv[$i])); // getting "s" from "-s"
			if($argv[$i+1][0] != '-')
				$options[$option_name]=$argv[$i+1];
			else
				$options[$option_name]="";
		}
		// Chegando aqui j temos o array $options[$option_name] definido para o $option_name desta iterao
		// Os que estiverem vazios, setar com alguma string dummy, pois o ""  confundindo com variaveis vazias, inexistentes ou nulas
		if($option_name != "") // Podemos estar tratando um campo que foi ignorado
			if($options[$option_name] == "")
				$options[$option_name]="@_@_DUMMY_@_@";
		
	}
	print_r($argv);
	print_r($options);
	return $options;
}

function parsea_recebe($string)
{
	echo "Recebeu: ".$string;
	
	$options=parsea_iptables_arg($string);
	
	return($options);
}

?>
